/* Metropolis update */

#include "comext.h"
#include <math.h>
#include <stdio.h>

void metupdate(nmet)
int nmet;
{
  int imet,i,j;
  short oldspin,newspin;
  short spin1,spin2,spin3,spin4;
  int old_energy,new_energy,diff;
  float pranf();
  short get_spin();

  num_accept = 0;

  for (imet=0;imet<nmet;imet++) {

     for (i=1;i<=isiz;i++) {
     for (j=1;j<=jsiz;j++) {

	   oldspin = spin[i][j];

	   /* Pick a new random trial spin */
	   newspin = (pranf() * (Q-1)) + 1;
	   newspin = (oldspin + newspin) % Q;
	   /* newspin = 1 - oldspin; */        /* only for Q=2 */

	   spin1 = get_spin(i-1,j);
	   spin2 = get_spin(i+1,j);
	   spin3 = get_spin(i,j-1);
	   spin4 = get_spin(i,j+1);

           old_energy = 0;
           new_energy = 0;

	   if (oldspin == spin1) old_energy++;
	   if (oldspin == spin2) old_energy++;
	   if (oldspin == spin3) old_energy++;
	   if (oldspin == spin4) old_energy++;

	   if (newspin == spin1) new_energy++;
	   if (newspin == spin2) new_energy++;
	   if (newspin == spin3) new_energy++;
	   if (newspin == spin4) new_energy++;

	   diff = old_energy - new_energy;  
           /* reversed due to - sign in energy */

	   if ((diff<=0) || (energy_table[diff] > pranf() )) {
	      num_accept++;
	      spin[i][j] = newspin;
           }

     }}  /* end of loop over sites */

  }  /* end of loop over sweeps */

  /* Pass edges to neighboring processors */
  spin_edges();

}

